/** 
 * ******************************************************************************
 * \file		main.c
 * \date		:  15 . 2021 .
 * \version		0.0a
 * \author		
 * 
 * ----------------------------------------------------------------------------
 * \brief		    FreeRTOS.
 * \details		http://kazus.ru/forums/showthread.php?t=120868
 *              
 *
 * ******************************************************************************
 */

/*
 * ============================================================================
 *   Includes
 * ============================================================================
 */
/*--- [MCU header (optional)] -----------*/
#include "stm32f10x.h"

/*--- [Std lib] -------------------------*/
#include <stdint.h>
#include <stdlib.h>
/*--- [Application Level] ---------------*/
#include "../FreeRTOS/motor_task.h"
#include "../FreeRTOS/buttons_task.h"
#include "../FreeRTOS/extctrl_task.h"

/*--- [Middleware Level] --------------*/

/*--- [System Level] --------------------*/
/*--- [RTOS Level] ----------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"

/*--- [Driver Level] ---------------------*/
#include "../Drivers/Motor/motor_drv.h"
#include "../Drivers/Buttons/buttons_drv.h"

/*
 * ============================================================================
 *   Declarations
 * ============================================================================
 */
/*---------------------------------------------------------
 *  [Global variables]
 */
TaskHandle_t pxMotor, pxButton, pxExtConrtol;  //  

/*
 * ============================================================================
 *
 *   Application Layer function
 *
 * ============================================================================
 */
/** \addtogroup AppLayer
 * @{ */

/** -------------------------------------------------------
 * \brief		   .
 * \details		 ,  ,
 * 				  .
 * \return		
 */
int main(void)
{
	/*---   ---------------------------*/
	Motor_IO_Init();
	Buttons_IO_Init();

	/*---  FreeRTOS --------------------------*/
	/*     */
	xTaskCreate(prvMotor,				// ,  
			"Motor",					//  
			configMINIMAL_STACK_SIZE,	//  
			NULL,						//    
			tskIDLE_PRIORITY + 1,		//  
			&pxMotor);					// 

	/*     */
	xTaskCreate(prvButton,
			"Buttons",
			configMINIMAL_STACK_SIZE,
			NULL,
			tskIDLE_PRIORITY + 1,
			&pxButton);

	/*     */
	xTaskCreate(prvExtConlrol,
			"External Control",
			configMINIMAL_STACK_SIZE,
			NULL,
			tskIDLE_PRIORITY + 1,
			&pxExtConrtol);

	/*   */
	vTaskStartScheduler();
	/*---- [Main Loop] -----------------------------*/
	while(1)
	{
	}
}/*---- main() ------------------------------------------*/

/** @} */

/** -------------------------------------------------------
 * \brief   Idle ( ).
 * \details     Sleep  , 
 *   .
 */
void vApplicationIdleHook(void)
{
	__WFI();   //  Sleep
}


/*==== END FILE =============================================================*/
