/** 
 * ******************************************************************************
 * \file		motor_drv.c
 * \date		:  15 . 2021 .
 * \version		0.0a
 * \author		
 * 
 * ----------------------------------------------------------------------------
 * \brief		  .
 * \details		      
 * 				 .
 * <table>
 * <caption> Pinout </caption>
 * <tr><th>  PORTA         </th>
 * <tr><td>  PA1 <-> OUT A </td>
 * <tr><td>  PA7 <-> OUT B </td>
 * </table>
 *
 * ******************************************************************************
 */

#include "motor_drv.h"

#include "stm32f10x.h"

/*
 * ============================================================================
 *   Declarations
 * ============================================================================
 */
/*---------------------------------------------------------
 *  [Defines]
 */
#define OUTA_Pin	1
#define OUTB_Pin	7


/*
 * ============================================================================
 *
 *   Public (Global) functions
 *
 * ============================================================================
 */
/** \addtogroup LL_Drv
 *  @{ */

/** -------------------------------------------------------
 * \brief		   
 * \details		PA1, PA7: PP OUT
 */
void Motor_IO_Init(void)
{
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;

	MODIFY_REG(GPIOA->CRL,
			GPIO_CRL_CNF1 | GPIO_CRL_CNF7,
			GPIO_CRL_MODE1_0 | GPIO_CRL_MODE7_0);
}//--------------------------------------------------------

/** -------------------------------------------------------
 * \brief     ,  .
 * \param direction -   (-1, 0, 1)
 */
void Motor_Drive(int8_t direction)
{
	switch (direction) {
		case 0:  //  ,  = 0
			GPIOA->BRR = (1 << OUTA_Pin) | (1 << OUTB_Pin);
			break;
		case -1: //  
			GPIOA->BRR = 1 << OUTA_Pin;
			GPIOA->BSRR = 1 << OUTB_Pin;
			break;
		case 1: //  
			GPIOA->BRR = 1 << OUTB_Pin;
			GPIOA->BSRR = 1 << OUTA_Pin;
			break;
	}
}//--------------------------------------------------------

/** -------------------------------------------------------
 * \brief  
 */
void Motor_Brake(void)
{
	GPIOA->BSRR = (1 << OUTA_Pin) | (1 << OUTB_Pin);
}//--------------------------------------------------------
/** @} */
/*==== END FILE =============================================================*/
