/** 
 * ******************************************************************************
 * \file		motor_task.c
 * \date		:  15 . 2021 .
 * \version		0.0a
 * \author		
 * 
 * ----------------------------------------------------------------------------
 * \brief		 " ".
 * \details		
 *              
 * ******************************************************************************
 */


/*
 * ============================================================================
 *   Includes
 * ============================================================================
 */
#include "motor_task.h"
/*--- [Std lib] -------------------------*/
#include <stdint.h>
#include <stdlib.h>

/*--- [System Level] --------------------*/

/*--- [RTOS Level] ----------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"

/*--- [Driver Level] --------------------*/
#include "../Drivers/Motor/motor_drv.h"
/*
 * ============================================================================
 *   Declarations
 * ============================================================================
 */
/*---------------------------------------------------------
 * 	[Types]
 */
/*---------------------------------------------------------
 * 	[Structs, Enums]
 */
/*---------------------------------------------------------
 *  [Defines]
 */
/*---------------------------------------------------------
 *  [Macros]
 */
/*---------------------------------------------------------
 *  [Private (static) variables]
 */
/*---------------------------------------------------------
 *  [External variables]
 */
/*---------------------------------------------------------
 *  [Global variables]
 */
/*---------------------------------------------------------
 *  [External function prototipes]
 */

/*
 * ============================================================================
 *
 *   Abstract: Private (Static) functions
 *
 * ============================================================================
 */



/*
 * ============================================================================
 *
 *   Abstract: Global (Public) functions
 *
 * ============================================================================
 */
/** @{ */
/** -------------------------------------------------------
 * \brief ,   "Motor"
 * \param *pvParameters -    
 */
void prvMotor(void *pvParameters)
{
	uint32_t command;	//    

	/*   */
	for(;;)
	{
		/*   .
		 *    ,  
		 *   Blocked     ,
		 *      */
		xTaskNotifyWait(0xFF,
						0xFF,
						&command,
						0xFFFF);

		/*      ,  
		 *  .
		 *      
		 *   
		 */
		switch(command){
		case 0:
			Motor_Drive(0);  //  
			break;
		case 1:
			Motor_Drive(1);  //  
			break;
		case 2:
			Motor_Drive(-1); //  
			break;
		case 3:
			Motor_Brake();  //  

		}

		/*    */
	}
}//--------------------------------------------------------

/** @} */
/*==== END FILE =============================================================*/
